(use-modules (mudsync)
             (oop goops))

;;                    MEDIAGOBLIN HQ
;; .-------------.--.--------.-----------.-----------.
;; | ====  ===== |  |        | elrond's  |           |
;; | ====  ===== |  | joar's | goblin    |           |
;; | Dootacenter |  + codea  | ballroom  |           |  <- here be
;; | ====  ===== +  | plex   |           |           |     gandaros
;; | ^-- chris's |  ;--------'----+--,---'           |
;; | emacs ai == |@ | schendje's     |               |
;; | server ==== |  | graphic design |   TOP SECRET  |
;; '-------------'  + sweatshop      +   LABORATORY  |
;; .--------+-----. |                |               |
;; | deb's        | '----------------'---------------'
;; | communication|  | | | | | | | | | <- stairs
;; | cooridoor    + _|_|_|_|_|_|_|_|_|
;; '--------------'

(define wooden-unlocked-door "A wooden door.  It appears to be unlocked.")
(define metal-stiff-door "A stiff metal door.
It looks like with a hard shove, you could step through it.")

(define goblin-rooms
  `((server-room
     ,<room>
     #:name "The dootacenter"
     #:desc
     "You've entered the server room.  The isles alternate between hot and cold
here.  It's not not very comfortable in here, and the combined noise of hundreds,
maybe thousands, of fans and various computing mechanisms creates an unpleasant
din.  Who'd choose to work in such a place?

Still, you have to admit that all the machines look pretty nice."
     ;; TODO: Allow walking around further in the dootacenter.
     #:exits
     ,(list (make <exit>
              #:name "east"
              #:to-symbol 'north-hallway
              #:desc wooden-unlocked-door)))  ; eventually make this locked so you have
                                             ; to kick it down, joeyh style!
    (north-hallway
     ,<room>
     #:name "North hallway"
     #:desc
     "You're at the north end of the hallway.  An open window gives a nice breeze,
and the curtains dance merrily in the wind.  Outside appears to be a pleasant
looking lawn.

The hallway continues to the south."
     #:exits
     ,(list (make <exit>
              #:name "west"
              #:to-symbol 'server-room
              #:desc wooden-unlocked-door)
            (make <exit>
              #:name "east"
              #:to-symbol 'code-a-plex
              #:desc metal-stiff-door)
            ;; (make <exit>
            ;;   #:name "south"
            ;;   #:to-symbol 'center-hallway)
            ))

    (code-a-plex
     ,<room>
     #:name "Joar's Code-A-Plex"
     #:desc
     "You've entered Joar's Code-A-Plex.  What that means is anyone's guess.
Joar apparently hangs out in here sometimes, but you don't see him here right
now.

There's a row of computer desks.  Most of them have computers already on them,
But one looks invitingly empty."
     #:exits
     ,(list (make <exit>
              #:name "west"
              #:to-symbol 'north-hallway
              #:desc metal-stiff-door)))))

(define (goblin-demo . args)
  (run-demo "/tmp/goblin-game.db" goblin-rooms 'north-hallway))
